Page MenuHomeFreeBSD

ip_output normalization and fixes
ClosedPublic

Authored by eri on Jul 8 2015, 3:37 PM.

Details

Summary

ip_output has a big chunk of code used to handle special cases with pfil consumers which also forces a reloop on it.
Gather all this code together to make it readable and properly handle the reloop cases.

Some of the issues identified:

  • M_IP_NEXTHOP is not handled properly in existing code.
  • route reference leaking is possible with in FIB number change
  • route flags checking is not consistent in the function

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

eri updated this revision to Diff 6778.Jul 8 2015, 3:37 PM
eri retitled this revision from to ip_output normalization and fixes.
eri updated this object.
eri edited the test plan for this revision. (Show Details)
eri added a reviewer: gnn.
eri set the repository for this revision to rS FreeBSD src repository.
eri added a project: network.
eri added a subscriber: network.
gnn accepted this revision.Jul 27 2015, 3:12 PM
gnn edited edge metadata.

Approved.

This revision is now accepted and ready to land.Jul 27 2015, 3:12 PM
This revision was automatically updated to reflect the committed changes.
ae added a subscriber: ae.Jul 30 2015, 9:19 AM

Do you plan to make similar change for IPv6?

eri added a comment.Jul 30 2015, 10:41 AM

Yea Andrey will do for IPv6.